#include "debouncer.h"
#include "macros.h"
#include "glog/logging.h"

namespace rm
{
    // int Debouncer::cycle_threshold_ = 4;
    void Debouncer::SetDebounce(const double lower, const double upper)
    {
        // DLOG(INFO) << PRINT(lower);
        // DLOG(INFO) << PRINT(upper);
        threshould_lower_ = lower;
        threshould_upper_ = upper;
    }

    bool Debouncer::RunDebouceLessTure(const double value)
    {
        if (firstrun_ == true){
            firstrun_ = false;
            state_prev_ = (value < threshould_lower_);
        }
        else{
            if (state_prev_ == true){
                state_prev_ = (value < threshould_upper_);
            }
            else{
                state_prev_ = (value < threshould_lower_);
            }
        }
        // cycle_ = state_prev_ ? cycle_ + 1 : 0;
        return state_prev_;
    }

    bool Debouncer::RunDebouceMoreTure(const double value)
    {
        if (firstrun_ == true){
            firstrun_ = false;
            state_prev_ = (value > threshould_upper_);
        }
        else{
            if (state_prev_ == true){
                state_prev_ = (value > threshould_lower_);
            }
            else{
                state_prev_ = (value > threshould_upper_);
            }
        }
        // cycle_ = state_prev_ ? cycle_ + 1 : 0;
        return state_prev_;
    }

    void Debouncer::ResetDebounce(){
        firstrun_ = true;
        state_prev_ = false;
    }

}
